unit FLPBD_Config;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls, NumEdits, Hotkeys;

type
  TConfigDialog = class(TForm)
    OKButton: TButton;
    CancelButton: TButton;
    OptionPage: TPageControl;
    WorkTab: TTabSheet;
    HistoryLbl: TLabel;
    HistoryEdt: TUpDownEdit;
    LockCountLbl: TLabel;
    ShortCutGrp: TGroupBox;
    InterceptChk: TCheckBox;
    ForwardKeyLbl: TLabel;
    ForwardKeyEdt: TGlobalHotkey;
    ForwardKeyDelBtn: TButton;
    BackwardKeyLbl: TLabel;
    BackwardKeyEdt: TGlobalHotkey;
    BackwardKeyDelBtn: TButton;
    HotClickLbl: TLabel;
    HotClickCbx: TComboBox;
    ShareGrp: TGroupBox;
    ShareChk: TCheckBox;
    PortLbl: TLabel;
    PortEdt: TNumericEdit;
    ViewTab: TTabSheet;
    HistoryGrp: TGroupBox;
    WidthLbl: TLabel;
    WidthEdt: TUpDownEdit;
    FontLbl: TLabel;
    FontBtn: TButton;
    PreviewGrp: TGroupBox;
    VisibleChk: TCheckBox;
    BreadthLbl: TLabel;
    BreadthEdt: TUpDownEdit;
    TypefaceLbl: TLabel;
    TypefaceBtn: TButton;
    FormatTab: TTabSheet;
    FormatLst: TListView;
    SendKeysTab: TTabSheet;
    SendKeysLst: TListView;
    TitleEdt: TEdit;
    ClassNameEdt: TEdit;
    StrokeEdt: TEdit;
    StrokeDelBtn: TButton;
    FindWndBtn: TButton;
    SendKeysRepBtn: TButton;
    SendKeysAddBtn: TButton;
    SendKeysDelBtn: TButton;
    LockTab: TTabSheet;
    LockLst: TListView;
    LockRatioLbl: TLabel;
    WarningLbl: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure HistoryEdtVerify(Sender: TObject; var AText: string; var APosition: Integer;
      Relation: TNumericallyRelationship);
    procedure ShortCutEdtsChange(Sender: TObject);
    procedure ForwardKeyDelBtnClick(Sender: TObject);
    procedure BackwardKeyDelBtnClick(Sender: TObject);
    procedure HorzWidthEdtsVerify(Sender: TObject; var AText: string; var APosition: Integer;
      Relation: TNumericallyRelationship);
    procedure FontTypeBtnsClick(Sender: TObject);
    procedure SendKeysLstSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
    procedure SendKeysEdtsChange(Sender: TObject);
    procedure StrokeEdtKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure StrokeEdtKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure StrokeDelBtnClick(Sender: TObject);
    procedure FindWndBtnMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure FindWndBtnMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure SendKeysRepBtnClick(Sender: TObject);
    procedure SendKeysAddBtnClick(Sender: TObject);
    procedure SendKeysDelBtnClick(Sender: TObject);
    procedure LockLstChange(Sender: TObject; Item: TListItem; Change: TItemChange);
  private
    { Private 錾 }
    FDownKeys: Integer;
    FPrevKey: Word;
    procedure UpdateSendKeys;
    procedure UpdateOKButton;
    procedure UpdateLocks;
  protected
    { protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
  public
    { Public 錾 }
  end;

var
  ConfigDialog: TConfigDialog;

implementation

{$R *.dfm}

uses
  FLPBD_Switch,
  Vcl.Consts, System.StrUtils, Vcl.Clipbrd, System.IOUtils, AppData, WndInfo;

resourcestring
  SHistory = '';
  SForwardKey = 'sL[';
  SBackwardKey = 'tsL[';
  SWidth = '';
  SBreadth = 'vr[';
  SDisaccord = '%s͈(%d-%d)Oł';
  SNonNumber = 's%sł';
  SUndefined = 'V[gJbgL[`ł';
  SDuplicate = 'sL[ƋtsL[dĂ܂';
  SContains = '%sML[Ɋ܂܂Ă܂';
  SLockCount = '(%d bN)';
  SLockRatio = 'bN: %d/%d';

procedure TConfigDialog.UpdateSendKeys;
var
  Selectable: Boolean;
  Item: TListItem;
begin
  Selectable := (TitleEdt.Text <> '') and (ClassNameEdt.Text <> '') and (StrokeEdt.Text <> '');
  for Item in SendkeysLst.Items do
  begin
    if SameText(Item.Caption, TitleEdt.Text) and SameText(Item.SubItems[0], ClassNameEdt.Text)
      and SameText(Item.SubItems[1], StrokeEdt.Text) then
    begin
      Selectable := False;
      Break;
    end;
  end;
  SendkeysRepBtn.Enabled := (SendkeysLst.SelCount > 0) and Selectable;
  SendkeysAddBtn.Enabled := Selectable;
  SendkeysDelBtn.Enabled := SendkeysLst.SelCount > 0;
end;

procedure TConfigDialog.UpdateOKButton;

  function SameSendkeys(KeyStroke: string): Boolean;
  var
    Item: TListItem;
    Key: string;
  begin
    Result := SameText(KeyStroke, 'Ctrl+V');
    if not Result then
      for Item in SendkeysLst.Items do
      begin
        for Key in SplitString(Item.SubItems[1], '|') do
        begin
          Result := SameText(KeyStroke, Key);
          if Result then
            Exit;
        end;
      end;
  end;

begin
  if HistoryEdt.Relation = nrDisaccord then
    WarningLbl.Caption := Format(SDisaccord, [SHistory, HistoryEdt.UpDown.Min, HistoryEdt.UpDown.Max])
  else if HistoryEdt.Relation = nrNonNumber then
    WarningLbl.Caption := Format(SNonNumber, [SHistory])
  else if (ForwardKeyEdt.HotKey = 0) and (BackwardKeyEdt.HotKey = 0) and (HotClickCbx.ItemIndex = 0) then
    WarningLbl.Caption := SUndefined
  else if (ForwardKeyEdt.HotKey > 0) and (ForwardKeyEdt.HotKey = BackwardKeyEdt.HotKey) then
    WarningLbl.Caption := SDuplicate
  else if SameSendkeys(ForwardKeyEdt.Text) then
    WarningLbl.Caption := Format(SContains, [SForwardKey])
  else if SameSendkeys(BackwardKeyEdt.Text) then
    WarningLbl.Caption := Format(SContains, [SBackwardKey])
  else if WidthEdt.Relation = nrDisaccord then
    WarningLbl.Caption := Format(SDisaccord, [SWidth, WidthEdt.UpDown.Min, WidthEdt.UpDown.Max])
  else if WidthEdt.Relation = nrNonNumber then
    WarningLbl.Caption := Format(SNonNumber, [SWidth])
  else if BreadthEdt.Relation = nrDisaccord then
    WarningLbl.Caption := Format(SDisaccord, [SBreadth, BreadthEdt.UpDown.Min, BreadthEdt.UpDown.Max])
  else if BreadthEdt.Relation = nrNonNumber then
    WarningLbl.Caption := Format(SNonNumber, [SBreadth])
  else
    WarningLbl.Caption := '';

  OKButton.Enabled := WarningLbl.Caption = '';
end;

procedure TConfigDialog.UpdateLocks;
var
  Count: Integer;
  Item: TListItem;
begin
  Count := 0;
  for Item in LockLst.Items do
  begin
    if Item.Checked then
      Inc(Count);
  end;
  LockCountLbl.Caption := Format(SLockCount, [Count]);
  LockRatioLbl.Caption := Format(SLockRatio, [Count, HistoryEdt.Value]);
end;

procedure TConfigDialog.CreateParams(var Params: TCreateParams);
begin
  inherited;

  Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW;
  Params.WndParent := Application.Handle;
end;

procedure TConfigDialog.FormCreate(Sender: TObject);
begin
  {$IFDEF RELEASE}
  OptionPage.TabIndex := 0;
  {$ENDIF RELEASE}

  FDownKeys := 0;
  FPrevKey := 0;
end;

procedure TConfigDialog.FormShow(Sender: TObject);
var
  i, j: Integer;
  s: string;
  Item: TListItem;
  Stream: TClipboardStream;
begin
  ShowWindow(Application.Handle, SW_HIDE);

  //Work
  HistoryEdt.Value := SwitchForm.HistoryMax;

  InterceptChk.Checked := SwitchForm.Interception;
  ForwardKeyEdt.HotKey := SwitchForm.ForwardKey;
  BackwardKeyEdt.HotKey := SwitchForm.BackwardKey;
  case SwitchForm.HotClick of
    VK_LBUTTON: HotClickCbx.ItemIndex := 1;
    VK_RBUTTON: HotClickCbx.ItemIndex := 2;
    VK_MBUTTON: HotClickCbx.ItemIndex := 3;
    VK_XBUTTON1: HotClickCbx.ItemIndex := 4;
    VK_XBUTTON2: HotClickCbx.ItemIndex := 5;
  else
    HotClickCbx.ItemIndex := 0;
  end;

  ShareChk.Checked := SwitchForm.TCPServer.Active;
  PortEdt.Int := SwitchForm.TCPServer.DefaultPort;

  //View
  WidthEdt.Value := SwitchForm.HistorySize;
  FontBtn.Font.Assign(SwitchForm.HistoryList.Font);
  FontBtn.Caption := FontBtn.Font.Name;

  VisibleChk.Checked := SwitchForm.PreviewImage.Visible;
  BreadthEdt.Value :=SwitchForm.PreviewSize;
  TypefaceBtn.Font.Assign(SwitchForm.PreviewFont);
  TypefaceBtn.Caption := TypefaceBtn.Font.Name;

  //Formats
  for i := 0 to FormatLst.Items.Count - 1 do
    FormatLst.Items.Item[i].Checked := False;
  for s in SwitchForm.Formats.Keys do
  begin
    Item := FormatLst.FindCaption(0, s, False, True, False);
    if Assigned(Item) then
      Item.Checked := True
    else
    begin
      Item := FormatLst.Items.Add;
      Item.Caption := s;
      Item.SubItems.Add(IntToStr(SwitchForm.Formats.Items[s]));
      Item.Checked := True;
    end;
  end;
  for i := 0 to Clipboard.FormatCount - 1 do
  begin
    j := Clipboard.Formats[i];
    s := FormatIdToName(j);
    if FormatLst.FindCaption(0, s, False, True, False) = nil then
    begin
      Item := FormatLst.Items.Add;
      Item.Caption := s;
      Item.SubItems.Add(IntToStr(j));
      Item.Checked := False;
    end;
  end;

  //SendKeys
  SendkeysLst.Items.Clear;
  for i := 0 to SwitchForm.SendKeys.Count - 1 do
  begin
    Item := SendkeysLst.Items.Add;
    Item.Caption := SwitchForm.SendKeys.Items[i].WindowTitle;
    Item.SubItems.Add(SwitchForm.SendKeys.Items[i].ClassName);
    Item.SubItems.Add(SwitchForm.SendKeys.Items[i].KeyStroke);
  end;
  UpdateSendKeys;

  //Lock
  LockLst.Items.Clear;
  for i := 0 to SwitchForm.HistoryList.Items.Count - 1 do
  begin
    Stream := TClipboardStream(SwitchForm.HistoryList.Items.Objects[i]);
    Item := LockLst.Items.Add;
    Item.Caption := SwitchForm.HistoryList.Items.Strings[i];
    Item.Data := Pointer(Stream);
    Item.Checked := Stream.FileName <> '';
  end;

  UpdateOKButton;
  UpdateLocks;
end;

procedure TConfigDialog.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  Item: TListItem;
  KeybdEvent: TKeybdEvent;
  Stream: TClipboardStream;
begin
  if ModalResult = mrOk then
  begin
    //Work
    SwitchForm.HistoryMax := HistoryEdt.Value;

    SwitchForm.Interception := InterceptChk.Checked;
    SwitchForm.ForwardKey := ForwardKeyEdt.HotKey;
    SwitchForm.BackwardKey := BackwardKeyEdt.HotKey;
    case HotClickCbx.ItemIndex of
      1: SwitchForm.HotClick := VK_LBUTTON;
      2: SwitchForm.HotClick := VK_RBUTTON;
      3: SwitchForm.HotClick := VK_MBUTTON;
      4: SwitchForm.HotClick := VK_XBUTTON1;
      5: SwitchForm.HotClick := VK_XBUTTON2;
    else
      SwitchForm.HotClick := 0;
    end;

    SwitchForm.TCPServer.Active := ShareChk.Checked;
    SwitchForm.TCPServer.DefaultPort := PortEdt.Int;

    //View
    SwitchForm.HistorySize := WidthEdt.Value;
    SwitchForm.HistoryList.Font.Assign(FontBtn.Font);

    SwitchForm.PreviewImage.Visible := VisibleChk.Checked;
    SwitchForm.PreviewSize := BreadthEdt.Value;
    SwitchForm.PreviewFont.Assign(TypefaceBtn.Font);

    //Formats
    SwitchForm.Formats.Clear;
    for Item in FormatLst.Items do
    begin
      if Item.Checked then
        SwitchForm.Formats.Add(Item.Caption, StrToInt(Item.SubItems[0]));
    end;

    //SendKeys
    SwitchForm.SendKeys.Clear;
    for Item in SendKeysLst.Items do
    begin
      KeybdEvent.WindowTitle := Item.Caption;
      KeybdEvent.ClassName := Item.SubItems[0];
      KeybdEvent.KeyStroke := Item.SubItems[1];
      SwitchForm.SendKeys.Add(KeybdEvent);
    end;

    //Lock
    for Item in LockLst.Items do
    begin
      Stream := TClipboardStream(Item.Data);
      if Item.Checked and (Stream.FileName = '') then
      begin
        Stream.FileName := TPath.Combine(
          AppDataName('ShaggyDog\Flipboard'), TPath.GetGUIDFileName) + '.cdo';
      end;
      if not Item.Checked and (Stream.FileName <> '') then
      begin
        DeleteFile(Stream.FileName);
        Stream.FileName := '';
      end;
    end;
  end;
end;

procedure TConfigDialog.HistoryEdtVerify(Sender: TObject; var AText: string; var APosition: Integer;
  Relation: TNumericallyRelationship);
begin
  UpdateOKButton;
  UpdateLocks;
end;

procedure TConfigDialog.ShortCutEdtsChange(Sender: TObject);
begin
  UpdateOKButton;
end;

procedure TConfigDialog.ForwardKeyDelBtnClick(Sender: TObject);
begin
  ForwardKeyEdt.ClearHotKey;
end;

procedure TConfigDialog.BackwardKeyDelBtnClick(Sender: TObject);
begin
  BackwardKeyEdt.ClearHotKey;
end;

procedure TConfigDialog.HorzWidthEdtsVerify(Sender: TObject; var AText: string; var APosition: Integer;
  Relation: TNumericallyRelationship);
begin
  UpdateOKButton;
end;

procedure TConfigDialog.FontTypeBtnsClick(Sender: TObject);
var
  Button: TButton;
  Dialog: TFontDialog;
begin
  Button := Sender as TButton;

  Dialog := TFontDialog.Create(Self);
  try
    Dialog.Font := Button.Font;
    if Dialog.Execute then
    begin
      Button.Font := Dialog.Font;
      Button.Caption := Dialog.Font.Name;
    end;
  finally
    Dialog.Free;
  end;
end;

procedure TConfigDialog.SendKeysLstSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
begin
  SendkeysDelBtn.Enabled := Selected;
  if Selected then
  begin
    TitleEdt.Text := Item.Caption;
    ClassNameEdt.Text := Item.SubItems[0];
    StrokeEdt.Text := Item.SubItems[1];
  end;
end;

procedure TConfigDialog.SendKeysEdtsChange(Sender: TObject);
begin
  UpdateSendKeys;
end;

procedure TConfigDialog.StrokeEdtKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if FPrevKey <> Key then
  begin
    FPrevKey := Key;

    if StrokeEdt.Text = srNone then
      StrokeEdt.Text := HotKeyToText(Key)
    else if FDownKeys > 0 then
      StrokeEdt.Text := StrokeEdt.Text + '+' + HotKeyToText(Key)
    else
      StrokeEdt.Text := StrokeEdt.Text + '|' + HotKeyToText(Key);
    StrokeEdt.SelStart := Length(StrokeEdt.Text);

    Inc(FDownKeys);
  end;
  Key := 0;
end;

procedure TConfigDialog.StrokeEdtKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if FDownKeys > 0 then
    Dec(FDownKeys);
  if (FDownKeys = 0) or (FPrevKey = Key) then
    FPrevKey := 0;
end;

procedure TConfigDialog.StrokeDelBtnClick(Sender: TObject);
begin
  if FDownKeys = 0 then
    StrokeEdt.Text := srNone;
end;

procedure TConfigDialog.FindWndBtnMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  FindWndBtn.Cursor := crCross;
  SetCapture(FindWndBtn.Handle);
end;

procedure TConfigDialog.FindWndBtnMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
var
  Wnd: HWND;
begin
  Wnd := GetAncestor(WindowFromPoint(Mouse.CursorPos), GA_ROOTOWNER);
  TitleEdt.Text := GetWindowTextStr(Wnd);
  ClassNameEdt.Text := GetClassNameStr(Wnd);
  FindWndBtn.Cursor := crDefault;
  ReleaseCapture;
end;

procedure TConfigDialog.SendKeysRepBtnClick(Sender: TObject);
begin
  SendKeysLst.Selected.Caption := TitleEdt.Text;
  SendKeysLst.Selected.SubItems[0] := ClassNameEdt.Text;
  SendKeysLst.Selected.SubItems[1] := StrokeEdt.Text;
  UpdateSendKeys;
  UpdateOKButton;
end;

procedure TConfigDialog.SendKeysAddBtnClick(Sender: TObject);
var
  NewItem: TListItem;
begin
  NewItem := SendkeysLst.Items.Add;
  NewItem.Caption := TitleEdt.Text;
  NewItem.SubItems.Add(ClassNameEdt.Text);
  NewItem.SubItems.Add(StrokeEdt.Text);
  NewItem.Selected := True;
  UpdateSendKeys;
  UpdateOKButton;
end;

procedure TConfigDialog.SendKeysDelBtnClick(Sender: TObject);
begin
  SendkeysLst.Selected.Delete;
  UpdateSendKeys;
  UpdateOKButton;
end;

procedure TConfigDialog.LockLstChange(Sender: TObject; Item: TListItem; Change: TItemChange);
begin
  UpdateLocks;
end;

end.
