unit FLPBD_Exit;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TExitDialog = class(TForm)
    OKButton: TButton;
    CancelButton: TButton;
    MessagePanel: TPanel;
    WarningImage: TImage;
    MessageLbl: TLabel;
    CountLbl: TLabel;
    CountTimer: TTimer;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CountTimerTimer(Sender: TObject);
  private
    { Private 錾 }
    function CountDown: Integer;
  protected
    { protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
  public
    { Public 錾 }
  end;

var
  ExitDialog: TExitDialog;

implementation

{$R *.dfm}

uses
  FLPBD_Switch,
  System.Generics.Collections;

resourcestring
  SCount = 'c: %d ';

function TExitDialog.CountDown: Integer;
var
  LockList: TList<TSendThread>;
begin
  LockList := SwitchForm.Connections.LockList;
  try
    Result := LockList.Count;
    CountLbl.Caption := Format(SCount, [Result]);
  finally
    SwitchForm.Connections.UnlockList;
  end;
end;

procedure TExitDialog.CreateParams(var Params: TCreateParams);
begin
  inherited;

  Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW;
  Params.WndParent := Application.Handle;
end;

procedure TExitDialog.FormShow(Sender: TObject);
begin
  ShowWindow(Application.Handle, SW_HIDE);

  CountDown;
  CountTimer.Enabled := True;
end;

procedure TExitDialog.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CountTimer.Enabled := False;
end;

procedure TExitDialog.CountTimerTimer(Sender: TObject);
begin
  if CountDown = 0 then
    ModalResult := mrOk;
end;

end.
