(*	AppData

Ver, 1.00 2007/11/17 ^B
Ver, 1.01 2010/04/08 CommonAppDataName ǉB
Ver, 1.02 2020/10/29 DeleteSection ǉB
Ver, 1.03 2021/02/19 TXMLRegFile B

inifile ֘AjbgB

Routine
AppDataName;	      %APPDATA%\DataName 𓾂B
CommonAppDataName:  %COMMON_APPDATA%\DataName 𓾂B

TAppIniFile
g TIniFileBAvP[Vf[^Ƃ͊֌WȂ肷B

\bh
WriteQuotedString;	lpt INI t@CɏށB
DeleteSection;      ZNV폜BZNV݂Ȃꍇ͉ȂiOȂjB
Clear;              ׂẴf[^폜B

LȊÕvpeBA\bh TIniFile ƓB

TXMLRegFile
XML hLgWXgɓǂݏNXB
CurrentNode ̎qm[ĥAP̃eLXgl̂f[^if[^m[hjA
Ȃ̂TuL[iTum[hjƂăANZXB
Xml.XMLIniFile.TXmlIniFile 邯ǁA^Ȃ̂ō쐬B

vpeB
FileName;     ǂݏ̑ΏۂɂȂt@CB
RootNode;     XML hLg̃[gm[hB
CurrentNode;  ݊JĂm[hB

\bh
OpenNode;       wm[hJB
                '\'Ŏn܂pX̓[g̐΃pXBႤȂJg̑΃pXB'..'Őẽm[hB
CloseNode;      Jgm[hA[gm[hJgɐݒB
NodeExists;     m[h݂邩ׂBpX̎w@ OpenNode ƓB
ValueExists;    f[^m[h݂邩ׂB
HasSubNodes;    Tum[h݂邩ׂB
GetNodeNames;   Tum[h̕񃊃XgԂB
GetValueNames;  f[^m[h̕񃊃XgԂB
CreateNode;     m[h쐬BpX̎w@ OpenNode ƓB
DeleteNode;     m[h폜BpX̎w@ OpenNode ƓB
DeleteValue;    f[^m[h폜B
ClearNodes;     Tum[hׂč폜B
ClearValues;    f[^m[hׂč폜B
Read(VALUE);    f[^m[h(VALUE)lǂݏoB
Read(VALUE)Def; f[^m[h݂Ȃꍇ Default lԂBłǂB
Write(VALUE);   f[^m[h(VALUE)lށB
UpdateFile;     t@CɏށBfXgN^Ă΂ꂽƂɎIɎsB

	%APPDATA% & inifile *)

unit AppData;

interface

uses
  Winapi.Windows, System.SysUtils, System.Classes, Winapi.ShlObj, System.IniFiles,
   Xml.XMLConst, Xml.XMLIntf, Xml.XMLDoc;

function AppDataName(DataName: string): string;
function CommonAppDataName(DataName: string): string;

type
  TAppIniFile = class(TIniFile)
  public
  { Public 錾 }
    procedure WriteQuotedString(const Section, Ident, Value: string);
    procedure DeleteSection(const Section: string);
    procedure Clear;
  end;

  TXMLRegFile = class(TObject)
  private
    { Private 錾 }
    FDocument: IXMLDocument;
    FCurrentNode: IXMLNode;
    FModified: Boolean;
    function IsAbsolute(const Value: string): Boolean;
    function GetFileName: string;
    procedure SetFileName(Value: string);
    function GetRootNode: IXMLNode;
  protected
    { protected 錾 }
  public
    { Public 錾 }
    constructor Create(const FileName: string);
    destructor Destroy; override;
    function OpenNode(const Path: string; CanCreate: Boolean): Boolean;
    procedure CloseNode;
    function NodeExists(const Path: string): Boolean;
    function ValueExists(const Name: string): Boolean;
    function HasSubNodes: Boolean;
    procedure GetNodeNames(Strings: TStrings);
    procedure GetValueNames(Strings: TStrings);
    function CreateNode(const Path: string): Boolean;
    function DeleteNode(const Path: string): Boolean;
    function DeleteValue(const Name: string): Boolean;
    procedure ClearNodes;
    procedure ClearValues;
    function ReadString(const Name: string): string;
    function ReadStrDef(const Name: string; Default: string): string;
    procedure WriteString(const Name: string; Value: String);
    function ReadInteger(const Name: string): Integer;
    function ReadIntDef(const Name: string; Default: Integer): Integer;
    procedure WriteInteger(const Name: string; Value: Integer);
    function ReadCardinal(const Name: string): Cardinal;
    function ReadUIntDef(const Name: string; Default: Cardinal): Cardinal;
    procedure WriteCardinal(const Name: string; Value: Cardinal);
    function ReadFloat(const Name: string): Double;
    function ReadFltDef(const Name: string; Default: Double): Double;
    procedure WriteFloat(const Name: string; Value: Double);
    function ReadBool(const Name: string): Boolean;
    function ReadBoolDef(const Name: string; Default: Boolean): Boolean;
    procedure WriteBool(const Name: string; Value: Boolean);
    procedure UpdateFile;
    property FileName: string read GetFileName write SetFileName;
    property RootNode: IXMLNode read GetRootNode;
    property CurrentNode: IXMLNode read FCurrentNode;
  end;

implementation

uses
  System.StrUtils;

{ Routine }

{ CSIDL\Name 𓾂 }
function DataPath(Folder: Integer; Name: string): string;
var
  PathName, FileName: string;
  Buf: array[0..MAX_PATH] of Char;
begin
  PathName := ExtractFileDir(Name);
  FileName := ExtractFileName(Name);
  SHGetSpecialFolderPath(0, Buf, Folder, False);
  PathName := Format('%s\%s', [Buf, PathName]);
  if not DirectoryExists(PathName) then
    ForceDirectories(PathName);
  Result := Format('%s\%s', [PathName, FileName]);
end;

{ %APPDATA%\DataName 𓾂 }
function AppDataName(DataName: string): string;
begin
  Result := DataPath(CSIDL_APPDATA, DataName);
end;

{ %COMMON_APPDATA%\DataName 𓾂 }
function CommonAppDataName(DataName: string): string;
begin
  Result := DataPath(CSIDL_COMMON_APPDATA, DataName);
end;

{ TAppIniFile }

procedure TAppIniFile.WriteQuotedString(const Section, Ident, Value: string);
begin
  WriteString(Section, Ident, Format('''%s''', [Value]));
end;

procedure TAppIniFile.DeleteSection(const Section: string);
begin
  if SectionExists(Section) then
    EraseSection(Section);
end;

procedure TAppIniFile.Clear;
var
  Sections: TStrings;
  i: Integer;
begin
  Sections := TStringList.Create;
  try
    ReadSections(Sections);
    for i := 0 to Sections.Count - 1 do
      EraseSection(Sections.Strings[i]);
  finally
    Sections.Free;
  end;
end;

{ TXMLRegFile }

constructor TXMLRegFile.Create(const FileName: string);
begin
  FDocument := NewXMLDocument;
  FDocument.FileName := FileName;
  FDocument.Options  := [doNodeAutoIndent];
  if FileExists(FDocument.FileName) then
    FDocument.LoadFromFile(FDocument.FileName)
  else
    FDocument.AddChild(ChangeFileExt(ExtractFileName(FDocument.FileName), ''));
  FModified := False; //FDocument.Modified ̓t@Cǂݍ񂾎 True ɂȂAύXiȂB
end;

destructor TXMLRegFile.Destroy;
begin
  if FModified and (FileName <> '') then
    UpdateFile;
  FDocument.Active := False;

  inherited;
end;

function TXMLRegFile.IsAbsolute(const Value: string): Boolean;
begin
  Result := (Value <> '') and (Value[1] = '\');
end;

function TXMLRegFile.GetFileName: string;
begin
  Result := FDocument.FileName;
end;

procedure TXMLRegFile.SetFileName(Value: string);
begin
  FDocument.FileName := Value;
end;

function TXMLRegFile.GetRootNode: IXMLNode;
begin
  Result := FDocument.DocumentElement;
end;

function TXMLRegFile.OpenNode(const Path: string; CanCreate: Boolean): Boolean;
var
  NodePath, NodeName: string;
  ParentNode, ChildNode: IXMLNode;
begin
  Result := True;
  try
    NodePath := Path;
    if IsAbsolute(NodePath) then
    begin
      Delete(NodePath, 1, 1);
      ParentNode := RootNode;
    end
    else
      ParentNode := CurrentNode;

    for NodeName in SplitString(NodePath, '\') do
    begin
      if NodeName = '..' then
        ChildNode := ParentNode.ParentNode
      else
        ChildNode := ParentNode.ChildNodes.FindNode(NodeName);
      if not Assigned(ChildNode) and (NodeName <> '..') then
      begin
        if CanCreate then
          ChildNode := ParentNode.AddChild(NodeName)
        else
          Abort;
      end;
      ParentNode := ChildNode;
    end;
    FCurrentNode := ParentNode;
  except
    Result := False;
  end;
end;

procedure TXMLRegFile.CloseNode;
begin
  FCurrentNode := RootNode;
end;

function TXMLRegFile.NodeExists(const Path: string): Boolean;
var
  OlgCurrent: IXMLNode;
begin
  OlgCurrent := FCurrentNode;
  try
    Result := OpenNode(Path, False);
  finally
    FCurrentNode := OlgCurrent;
  end;
end;

function TXMLRegFile.ValueExists(const Name: string): Boolean;
begin
  Result := FCurrentNode.ChildNodes.IndexOf(Name) > 0;
end;

function TXMLRegFile.HasSubNodes: Boolean;
var
  i: Integer;
begin
  Result := False;
  for i := 0 to FCurrentNode.ChildNodes.Count - 1 do
  begin
    if not FCurrentNode.ChildNodes.Nodes[i].IsTextElement then
    begin
      Result := True;
      Exit;
    end;
  end;
end;

procedure TXMLRegFile.GetNodeNames(Strings: TStrings);
var
  i: Integer;
begin
  for i := 0 to FCurrentNode.ChildNodes.Count - 1 do
  begin
    if not FCurrentNode.ChildNodes.Nodes[i].IsTextElement then
      Strings.Add(FCurrentNode.ChildNodes.Nodes[i].NodeName);
  end;
end;

procedure TXMLRegFile.GetValueNames(Strings: TStrings);
var
  i: Integer;
begin
  for i := 0 to FCurrentNode.ChildNodes.Count - 1 do
  begin
    if FCurrentNode.ChildNodes.Nodes[i].IsTextElement then
      Strings.Add(FCurrentNode.ChildNodes.Nodes[i].NodeName);
  end;
end;

function TXMLRegFile.CreateNode(const Path: string): Boolean;
var
  OlgCurrent: IXMLNode;
begin
  OlgCurrent := FCurrentNode;
  try
    Result := OpenNode(Path, True);
  finally
    FCurrentNode := OlgCurrent;
  end;
  FModified := True;
end;

function TXMLRegFile.DeleteNode(const Path: string): Boolean;
var
  NodePath, NodeName: string;
  OlgCurrent: IXMLNode;
begin
  OlgCurrent := FCurrentNode;
  try
    NodePath := ExtractFilePath(Path);
    NodeName := ExtractFileName(Path);

    Result := OpenNode(NodePath, False);
    if Result then
      Result := FCurrentNode.ChildNodes.Delete(NodeName) > 0;
    if Result then
      FModified := True;
  finally
    FCurrentNode := OlgCurrent;
  end;
end;

function TXMLRegFile.DeleteValue(const Name: string): Boolean;
begin
  Result := FCurrentNode.ChildNodes.Delete(Name) > 0;
  if Result then
    FModified := True;
end;

procedure TXMLRegFile.ClearNodes;
var
  i: Integer;
begin
  for i := FCurrentNode.ChildNodes.Count - 1 downto 0 do
  begin
    if not FCurrentNode.ChildNodes.Nodes[i].IsTextElement then
      FCurrentNode.ChildNodes.Delete(i);
  end;
  FModified := True;  //B
end;

procedure TXMLRegFile.ClearValues;
var
  i: Integer;
begin
  for i := FCurrentNode.ChildNodes.Count - 1 downto 0 do
  begin
    if FCurrentNode.ChildNodes.Nodes[i].IsTextElement then
      FCurrentNode.ChildNodes.Delete(i);
  end;
  FModified := True;  //ClearNodes ƓB
end;

function TXMLRegFile.ReadString(const Name: string): string;
var
  ChildNode: IXMLNode;
begin
  ChildNode := FCurrentNode.ChildNodes.FindNode(Name);
  if Assigned(ChildNode) then
    Result := ChildNode.Text
  else
    raise EXMLDocError.CreateFmt(SNodeNotFound, [Name]);
end;

function TXMLRegFile.ReadStrDef(const Name: string; Default: string): string;
var
  ChildNode: IXMLNode;
begin
  ChildNode := FCurrentNode.ChildNodes.FindNode(Name);
  if Assigned(ChildNode) then
    Result := ChildNode.Text
  else
    Result := Default;
end;

procedure TXMLRegFile.WriteString(const Name: string; Value: String);
var
  ChildNode: IXMLNode;
begin
  ChildNode := FCurrentNode.ChildNodes.FindNode(Name);
  if not Assigned(ChildNode) then
    ChildNode := FCurrentNode.AddChild(Name);
  ChildNode.Text := Value;
  FModified := True;
end;

function TXMLRegFile.ReadInteger(const Name: string): Integer;
var
  ChildNode: IXMLNode;
begin
  ChildNode := FCurrentNode.ChildNodes.FindNode(Name);
  if Assigned(ChildNode) then
    Result := StrToInt(ChildNode.Text)
  else
    raise EXMLDocError.CreateFmt(SNodeNotFound, [Name]);
end;

function TXMLRegFile.ReadIntDef(const Name: string; Default: Integer): Integer;
var
  ChildNode: IXMLNode;
begin
  ChildNode := FCurrentNode.ChildNodes.FindNode(Name);
  if Assigned(ChildNode) then
    Result := StrToInt(ChildNode.Text)
  else
    Result := Default;
end;

procedure TXMLRegFile.WriteInteger(const Name: string; Value: Integer);
var
  ChildNode: IXMLNode;
begin
  ChildNode := FCurrentNode.ChildNodes.FindNode(Name);
  if not Assigned(ChildNode) then
    ChildNode := FCurrentNode.AddChild(Name);
  ChildNode.Text := IntToStr(Value);
  FModified := True;
end;

function TXMLRegFile.ReadCardinal(const Name: string): Cardinal;
var
  ChildNode: IXMLNode;
begin
  ChildNode := FCurrentNode.ChildNodes.FindNode(Name);
  if Assigned(ChildNode) then
    Result := StrToUInt(ChildNode.Text)
  else
    raise EXMLDocError.CreateFmt(SNodeNotFound, [Name]);
end;

function TXMLRegFile.ReadUIntDef(const Name: string; Default: Cardinal): Cardinal;
var
  ChildNode: IXMLNode;
begin
  ChildNode := FCurrentNode.ChildNodes.FindNode(Name);
  if Assigned(ChildNode) then
    Result := StrToUInt(ChildNode.Text)
  else
    Result := Default;
end;

procedure TXMLRegFile.WriteCardinal(const Name: string; Value: Cardinal);
var
  ChildNode: IXMLNode;
begin
  ChildNode := FCurrentNode.ChildNodes.FindNode(Name);
  if not Assigned(ChildNode) then
    ChildNode := FCurrentNode.AddChild(Name);
  ChildNode.Text := UIntToStr(Value);
  FModified := True;
end;

function TXMLRegFile.ReadFloat(const Name: string): Double;
var
  ChildNode: IXMLNode;
begin
  ChildNode := FCurrentNode.ChildNodes.FindNode(Name);
  if Assigned(ChildNode) then
    Result := StrToFloat(ChildNode.Text)
  else
    raise EXMLDocError.CreateFmt(SNodeNotFound, [Name]);
end;

function TXMLRegFile.ReadFltDef(const Name: string; Default: Double): Double;
var
  ChildNode: IXMLNode;
begin
  ChildNode := FCurrentNode.ChildNodes.FindNode(Name);
  if Assigned(ChildNode) then
    Result := StrToFloat(ChildNode.Text)
  else
    Result := Default;
end;

procedure TXMLRegFile.WriteFloat(const Name: string; Value: Double);
var
  ChildNode: IXMLNode;
begin
  ChildNode := FCurrentNode.ChildNodes.FindNode(Name);
  if not Assigned(ChildNode) then
    ChildNode := FCurrentNode.AddChild(Name);
  ChildNode.Text := FloatToStr(Value);
  FModified := True;
end;

function TXMLRegFile.ReadBool(const Name: string): Boolean;
var
  ChildNode: IXMLNode;
begin
  ChildNode := FCurrentNode.ChildNodes.FindNode(Name);
  if Assigned(ChildNode) then
    Result := StrToBool(ChildNode.Text)
  else
    raise EXMLDocError.CreateFmt(SNodeNotFound, [Name]);
end;

function TXMLRegFile.ReadBoolDef(const Name: string; Default: Boolean): Boolean;
var
  ChildNode: IXMLNode;
begin
  ChildNode := FCurrentNode.ChildNodes.FindNode(Name);
  if Assigned(ChildNode) then
    Result := StrToBool(ChildNode.Text)
  else
    Result := Default;
end;

procedure TXMLRegFile.WriteBool(const Name: string; Value: Boolean);
var
  ChildNode: IXMLNode;
begin
  ChildNode := FCurrentNode.ChildNodes.FindNode(Name);
  if not Assigned(ChildNode) then
    ChildNode := FCurrentNode.AddChild(Name);
  ChildNode.Text := BoolToStr(Value);
  FModified := True;
end;

procedure TXMLRegFile.UpdateFile;
var
  XMLText: TStrings;
begin
  //FDocument.SaveToFile ƁACfgƂB
  XMLText := TStringList.Create;
  try
    XMLText.Text := FormatXMLData(FDocument.XML.Text);
    XMLText.SaveToFile(FDocument.FileName);
  finally
    XMLText.Free;
  end;
end;

end.
