(* ShellNotifyIcon

Ver, 1.00 2012/04/28 ^B
Ver, 1.11 2014/10/05 ו߁BȑO TShellNotifyIcon ɂ킹ăo[WԍXVB
Ver, 1.12 2017/12/10 ^C}[gčĎs悤ɕύXB
Ver, 1.13 2018/11/18 Visible vpeB̎dlύXB
Ver, 1.14 2020/10/03 pbgy[WύXBShellConsts ύXɒǏ]B

NIM_ADD s΍{ TTrayIcon

Cxg
OnShowAttempted:  gCACRo^sIɔBۂ Visible vpeBŔfB

vpeB
RetryCount:    gCACRo^Ďs񐔁B[ŎsȂB}CiXŖɎsB
RetryInterval: sԊuB
RetryStep:     sc񐔁B
Visible:       gCACR̕\ԁBnot Animate and Assigned(Icons) ̎ IconIndex ̃ACRgpB

\bh
Show:          gCACR̕\B
Hide:          gCACR̔\B

ق̃CxgAvpeBA\bh TTrayIcon ƓB

TShellNotifyIcon.Show ĂяoƃgCACRo^AHide ŉB
o^ɎsƂ́A Visible = False ɖ߂ARetryInterval ~bԊu RetryCount o^݂B
Visible vpeB𒼐ڕύXꍇ TTrayIcon ƓB

  ^XNgCACR *)

unit ShellNotifyIcon;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Classes, Vcl.Forms, Vcl.ExtCtrls;

type
  TShellNotifyIcon = class(TCustomTrayIcon)
  private
    { Private 錾 }
    FRetryCount,
    FRetryStep: Integer;
    FTimer: TTimer;
    FOnShowAttempted: TNotifyEvent;
    function GetRetryInterval: Cardinal;
    procedure SetRetryInterval(Value: Cardinal);
  protected
    { Protected 錾 }
    procedure WindowProc(var Message: TMessage); override;
    procedure SetVisible(Value: Boolean); override;
    procedure DoShowRetry(Sender: TObject); virtual;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Show;
    procedure Hide;
    property RetryStep: Integer read FRetryStep;
  published
    { Published 錾 }
    property RetryCount: Integer read FRetryCount write FRetryCount default 10;
    property RetryInterval: Cardinal read GetRetryInterval write SetRetryInterval default 1000;
    property OnShowAttempted: TNotifyEvent read FOnShowAttempted write FOnShowAttempted;

    property Animate;
    property AnimateInterval;
    property Hint;
    property BalloonHint;
    property BalloonTitle;
    property BalloonTimeout;
    property BalloonFlags;
    property Icon;
    property Icons;
    property IconIndex;
    property PopupMenu;
    property Visible;
    property OnBalloonClick;
    property OnClick;
    property OnDblClick;
    property OnMouseMove;
    property OnMouseUp;
    property OnMouseDown;
    property OnAnimate;
  end;

procedure Register;

implementation

uses
  ShellConsts, Winapi.ShellAPI, Vcl.Consts;

var
  RM_TaskbarCreated: DWORD;

procedure TShellNotifyIcon.DoShowRetry(Sender: TObject);
begin
  FTimer.Enabled := False;
  Visible := True;
  if Refresh(NIM_MODIFY) then
    FRetryStep := 0
  else
  begin
    try
      Visible := False;
    except
      on E: EOutOfResources do {};
    end;
    if FRetryStep > 0 then
      Dec(FRetryStep);
    FTimer.Enabled := FRetryStep <> 0;
  end;

  if (FRetryStep = 0) and Assigned(FOnShowAttempted) then
    FOnShowAttempted(Self);
end;

constructor TShellNotifyIcon.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FRetryCount := 10;
  FRetryStep := 0;
  FTimer := TTimer.Create(nil);
  FTimer.Enabled := False;
  FTimer.Interval := 1000;
  FTimer.OnTimer := DoShowRetry;
end;

procedure TShellNotifyIcon.SetVisible(Value: Boolean);
var
  OrigIco: Integer;
begin
  inherited SetVisible(Value);

  //TCustomTrayIcon ł́AVisible ςƂɃftHgACR\BO炾H
  if not Animate and Assigned(Icons) then
  begin
    OrigIco := IconIndex;
    try
      IconIndex := -1;
    finally
      IconIndex := OrigIco;
    end;
  end;
end;

procedure TShellNotifyIcon.WindowProc(var Message: TMessage);
begin
  inherited WindowProc(Message);

  if (Cardinal(Message.Msg) = RM_TaskBarCreated) and Visible then
  begin
    if Refresh(NIM_MODIFY) then
    begin
      if Assigned(FOnShowAttempted) then
        FOnShowAttempted(Self);
    end
    else
    begin
      try
        Visible := False;
      except
        on E: EOutOfResources do {};
      end;
      if FRetryCount <> 0 then
      begin
        FRetryStep := FRetryCount;
        FTimer.Enabled := True;
      end;
    end;
  end;
end;

destructor TShellNotifyIcon.Destroy;
begin
  FTimer.Free;

  inherited Destroy;
end;

procedure TShellNotifyIcon.Show;
begin
  FTimer.Enabled := False;
  Visible := True;
  if Refresh(NIM_MODIFY) then
  begin
    if Assigned(FOnShowAttempted) then
      FOnShowAttempted(Self);
  end
  else
  begin
    try
      Visible := False;
    except
      on E: EOutOfResources do {};
    end;
    if FRetryCount <> 0 then
    begin
      FRetryStep := FRetryCount;
      FTimer.Enabled := True;
    end;
  end;
end;

procedure TShellNotifyIcon.Hide;
begin
  FTimer.Enabled := False;
  FRetryStep := 0;
  Visible := False;
end;

function TShellNotifyIcon.GetRetryInterval: Cardinal;
begin
  Result := FTimer.Interval;
end;

procedure TShellNotifyIcon.SetRetryInterval(Value: Cardinal);
begin
  FTimer.Interval := Value;
end;

procedure Register;
begin
  RegisterComponents(SPalletePage, [TShellNotifyIcon]);
end;

initialization
  RM_TaskBarCreated := RegisterWindowMessage('TaskbarCreated');

end.
