(* Socket Utils

Ver, 1.00 2016/11/13 ^B
Ver, 1.01 2018/12/16 EnumServers CB

Winsock ֌W[eBeBB
Indy10 ɂ NetServerEnum ̋@\H
IPv4 ̂ݑΉB
Ƃ肠AKvȕB

  Winsock ֌W[eBeB *)

unit SocketUtils;

interface

uses
  Winapi.Windows, System.SysUtils, System.Classes, Winapi.Winsock;

type
  PServerInfo100 = ^TServerInfo100;
  NET_API_STATUS = DWORD;

  TServerInfo100 = record
    sv100_platform_id: DWORD;
    sv100_name: PWideChar;
  end;

const
  //NET_API_STATUS
  NERR_Success = 0;

  //prefmaxlen
  MAX_PREFERRED_LENGTH = DWORD(-1);

  //servertype
  SV_TYPE_WORKSTATION       = $00000001;
  SV_TYPE_SERVER            = $00000002;
  SV_TYPE_SQLSERVER         = $00000004;
  SV_TYPE_DOMAIN_CTRL       = $00000008;
  SV_TYPE_DOMAIN_BAKCTRL    = $00000010;
  SV_TYPE_TIMESOURCE        = $00000020;
  SV_TYPE_AFP               = $00000040;
  SV_TYPE_NOVELL            = $00000080;
  SV_TYPE_DOMAIN_MEMBER     = $00000100;
  SV_TYPE_LOCAL_LIST_ONLY   = $40000000;
  SV_TYPE_PRINT             = $00000200;
  SV_TYPE_DIALIN            = $00000400;
  SV_TYPE_XENIX_SERVER      = $00000800;
  SV_TYPE_MFPN              = $00004000;
  SV_TYPE_NT                = $00001000;
  SV_TYPE_WFW               = $00002000;
  SV_TYPE_SERVER_NT         = $00008000;
  SV_TYPE_POTENTIAL_BROWSER = $00010000;
  SV_TYPE_BACKUP_BROWSER    = $00020000;
  SV_TYPE_MASTER_BROWSER    = $00040000;
  SV_TYPE_DOMAIN_MASTER     = $00080000;
  SV_TYPE_DOMAIN_ENUM       = $80000000;
  SV_TYPE_WINDOWS           = $00400000;
  SV_TYPE_ALL               = $FFFFFFFF;

function NetServerEnum(servername: LPCWSTR; level: DWORD; var bufptr: Pointer;
  prefmaxlen: DWORD; var entriesread, totalentries: DWORD; servertype: DWORD;
  domain: LPCWSTR; resume_handle: LPDWORD): NET_API_STATUS; stdcall; external 'netapi32.dll';
function NetApiBufferFree(Buffer: Pointer): NET_API_STATUS; stdcall; external 'netapi32.dll';

function EnumServer(ServerType: DWORD; List: TStrings): NET_API_STATUS;
function GetServerName(const ServerAddress: string): string;
function GetServerAddress(const ServerName: string): string;
function LocalHostName: string;
function LocalHostAddress: string;

implementation

function EnumServer(ServerType: DWORD; List: TStrings): NET_API_STATUS;
var
  Buffer: Pointer;
  EntriesRead, TotalEntries: DWORD;
  ServerInfo: PServerInfo100;
  i: Integer;
begin
  Result := NetServerEnum(nil, 100, Buffer,
    MAX_PREFERRED_LENGTH, EntriesRead, TotalEntries, ServerType, nil, nil);
  try
    if Result in [NERR_Success, ERROR_MORE_DATA] then
    begin
      ServerInfo := PServerInfo100(Buffer);
      for i := 0 to EntriesRead - 1 do
      begin
        List.Add(ServerInfo.sv100_name);
        Inc(ServerInfo);
      end;
    end;
  finally
    NetApiBufferFree(Buffer);
  end;
end;

function GetServerName(const ServerAddress: string): string;
var
  WSAData: TWSAData;
  HostEnt: PHostEnt;
  InAddr: TInAddr;
begin
  Result := '';
  if WSAStartup($101, WSAData) = 0 then
  begin
    try
      InAddr.S_addr := inet_addr(PAnsiChar(AnsiString(ServerAddress)));
      HostEnt := gethostbyaddr(@InAddr, 4, PF_INET);

      if Assigned(HostEnt) then
        Result := string(HostEnt^.h_name);
    finally
      WSACleanup;
    end;
  end;
end;

function GetServerAddress(const ServerName: string): string;
var
  WSAData: TWSAData;
  HostEnt: PHostEnt;
  InAddr: TInAddr;
begin
  Result := '';
  if WSAStartup($101, WSAData) = 0 then
  begin
    try
      HostEnt := gethostbyname(PAnsiChar(AnsiString(ServerName)));
      if Assigned(HostEnt) then
        InAddr := PInAddr(HostEnt^.h_addr_list^)^;
      Result := string(inet_ntoa(InAddr));
    finally
      WSACleanup;
    end;
  end;
end;

function LocalHostName: string;
begin
  Result := GetServerName('127.0.0.1');
end;

function LocalHostAddress: string;
begin
  Result := GetServerAddress(LocalHostName);
end;

end.
